use crate::http_client::HttpClient;
use crate::data_toml;
use crate::url;
use iso8601_timestamp::Timestamp;
use serde_json::json;

pub async fn post_request(text: String, link: String, s: i32, e: i32) -> String {
    let did = data_toml(&"did");
    let handle = data_toml(&"handle");
    let url = url(&"record_create");
    let col = "app.bsky.feed.post".to_string();

    let d = Timestamp::now_utc();
    let d = d.to_string();

    let post = json!({
        "repo": handle.to_string(),
        "did": did.to_string(),
        "collection": col.to_string(),
        "record": {
            "text": link.to_string() + &" ".to_string() + &text.to_string(),
            "createdAt": d.to_string(),
            "facets": [
            {
                "index": {
                    "byteStart": s,
                    "byteEnd": e
                },
                "features": [
                {
                    "$type": "app.bsky.richtext.facet#link",
                    "uri": link.to_string()
                }
                ]
            }
            ],
        },
    });

    let client = HttpClient::new();
    
    match client.post_json_with_auth(&url, &post).await {
        Ok(response) => response,
        Err(e) => format!("Error: {}", e),
    }
}
